"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PriorityQueue = exports.EMPTY = void 0;
const binary_heap_strategy_1 = require("./binary-heap-strategy");
exports.EMPTY = undefined;
class PriorityQueue {
    constructor(options = {}) {
        var _a;
        options.strategy || (options.strategy = binary_heap_strategy_1.BinaryHeapStrategy);
        options.comparator || (options.comparator = (a, b) => (a || 0) - (b || 0));
        this.strategy = new options.strategy(options);
        this._length = ((_a = options === null || options === void 0 ? void 0 : options.initialValues) === null || _a === void 0 ? void 0 : _a.length) || 0;
    }
    get length() {
        return this._length;
    }
    queue(value) {
        this._length++;
        this.strategy.queue(value);
    }
    dequeue() {
        if (!this._length)
            throw new Error('Empty queue');
        this._length--;
        return this.strategy.dequeue();
    }
    peek() {
        if (this._length === 0)
            return exports.EMPTY;
        return this.strategy.peek();
    }
    clear() {
        this._length = 0;
        return this.strategy.clear();
    }
}
exports.PriorityQueue = PriorityQueue;
//# sourceMappingURL=priority-queue.js.map